{  **************************************************************************
      :
       ALLOCATEBUFFER, FREEBUFFER,
       DMAALL, DMA_OFF, DMA_COUNTER_IN
      32 BIT  LCARD_32.DLL
   ************************************************************************** }

program DiskTime;
uses
    Windows, Sysutils, LCard_32;

const
    MyX=512*64;                          { 32 KW = 64 KB }
    Count:cardinal=16;
    FreeTime:extended=0;
    Overflow:boolean=False;

type
    TData=array[0..1, 0..MyX-1] of word; { 64 KW = 128 KB }
    PTData=^TData;

var
    PLinear  :PTData;
    PPhysical:PTData;
    i        :cardinal;
    Nch      :cardinal;
    Rate     :cardinal;
    Time1    :DWORD;
    Time2    :DWORD;
    Number   :DWORD;
    Channels :array[0..15] of word;
    hFile    :THandle;


{*****************************************************************************}
Begin
    Nch:=8;
    Rate:=32;

    CONFIG_FIFO(1);

    for i:=0 to Nch-1 do Channels[i]:=i;

    ALLOCATEBUFFER(MyX*2*2, PLinear, PPhysical);
    WriteLN('PLinear:   ', IntToHex(Cardinal(PLinear), 8));
    WriteLN('PPhysical: ', IntToHex(Cardinal(PPhysical), 8));
    if PLinear=NIL then
    Begin
        WriteLN('Unable To Allocate Physical Memory.');
        Halt(255);
    End;

    hFile:=CreateFile('DISK32.BIN',
                       GENERIC_WRITE,
                       0,
                       NIL,
                       CREATE_ALWAYS,
                       FILE_ATTRIBUTE_ARCHIVE { or FILE_FLAG_NO_BUFFERING },
                       0
                      );

    Time1:=GetCurrentTime;
    for i:=1 to Count do
    Begin
        WriteFile(hFile, PLinear^[0, 0], MyX*2, Number, NIL);
        DMA_COUNTER_IN;
        DMA_COUNTER_IN;
        WriteFile(hFile, PLinear^[1, 0], MyX*2, Number, NIL);
        DMA_COUNTER_IN;
        DMA_COUNTER_IN;
    End;
    Time2:=GetCurrentTime;


    if Time2=Time1 then Inc(Time2);

    WriteLN('Maximum Transfer Disk Write Operation: ', Count*MyX*2*2/(Time2-Time1):5:2, ' KB/S');

    FlushFileBuffers(hFile);

    SetFilePointer(hFile, 0, NIL, FILE_BEGIN);

    Sleep(10000);

    DMAALL(PPhysical^, MyX*2, Channels, Nch, Rate, 1);


    Time1:=GetCurrentTime;
    for i:=1 to Count do
    Begin
        WriteFile(hFile, PLinear^[0, 0], MyX*2, Number, NIL);
        DMA_COUNTER_IN;
        DMA_COUNTER_IN;
        WriteFile(hFile, PLinear^[1, 0], MyX*2, Number, NIL);
        DMA_COUNTER_IN;
        DMA_COUNTER_IN;
    End;
    Time2:=GetCurrentTime;


    if Time2=Time1 then Inc(Time2);

    WriteLN('Passive Transfer Disk Write Operation: ', Count*MyX*2*2/(Time2-Time1):5:2, ' KB/S');

    FlushFileBuffers(hFile);

    SetFilePointer(hFile, 0, NIL, FILE_BEGIN);

    Sleep(10000);

    {                            Buffer[0, X], Buffer[1, X] }
    { Counter:           65535   65534..32767, 32766..65535 }
    { Counter+1:         65536   65535..32768, 32767..    0 }
    { 65536-(Counter+1):     0       1..32768, 32769..65536 }

    while (DMA_COUNTER_IN+1)>MyX do Sleep(1);

    Time1:=GetCurrentTime;
    for i:=1 to Count do
    Begin
                                        { Buffer[0] - OK, Buffer[1] - WORK }
        WriteFile(hFile, PLinear^[0, 0], MyX*2, Number, NIL);
        if (DMA_COUNTER_IN+1)>MyX then
        Begin
            Overflow:=True;
            while (DMA_COUNTER_IN+1)>MyX do Sleep(0);
        End;
        Time2:=GetCurrentTime;
        while (DMA_COUNTER_IN+1)<MyX do Sleep(0);
        FreeTime:=GetCurrentTime-Time2;
                                        { Buffer[0] - WORK, Buffer[1] - OK }
        WriteFile(hFile, PLinear^[1, 0], MyX*2, Number, NIL);
        if (DMA_COUNTER_IN+1)<MyX then
        Begin
            Overflow:=True;
            while (DMA_COUNTER_IN+1)<MyX do Sleep(0);
        End;
        Time2:=GetCurrentTime;
        while (DMA_COUNTER_IN+1)>MyX do Sleep(0);
        FreeTime:=GetCurrentTime-Time2;
    End;
    Time2:=GetCurrentTime;

    DMA_OFF;

    FREEBUFFER(PLinear^);

    if Time2=Time1 then Inc(Time2);

    WriteLN('Current Transfer Disk Write Operation: ', Count*MyX*2*2/(Time2-Time1):5:2, ' KB/S');

    CloseHandle(hFile);

    WriteLN('Estimated Time: ', (1.0*Count*MyX*Rate/500/Nch):8:2, ' MS');
    WriteLN('Elapsed   Time: ', (1.0*(Time2-Time1)):8:2, ' MS');
    WriteLN('Differens Time: ', Abs(1.0*Count*MyX*Rate/500/Nch-(Time2-Time1)):8:2, ' MS');
    WriteLN('Half      Time: ', (1.0*MyX*Rate/1000/Nch):8:2, ' MS');
    WriteLN('Free      Time: ', ((FreeTime*256/MyX/Count)/(1)):8:2, ' MS/KB');

    if Overflow then WriteLN('Warning!!!#13#10 Buffer Overflow.');
    if Abs(2.0*Count*MyX*Rate/Nch-1000.0*(Time2-Time1))>(MyX*Rate) then WriteLN('Warning!!!#13#10 Buffer Missing.');
End.
