#include "lcard_ad.h"
#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <FCNTL.H>
#include <io.h>
#include <string.h>
#include "example.h"
#include "l1221.h"
#include "ui_attr.h"
#include "userint.h"
#include "l1221dos.h"
#include "lutil_lw.h"
#include "lcard_lw.h"

static int Pnl;
int L1221On;
int FifoFlag;
int Gain;
int GridOn;
int AutoScale;
int Rate, RateScale;
short Data[2048], DataGraph[512];
int GraphCtrl[4]={MAIN_GRAPH1,MAIN_GRAPH2,MAIN_GRAPH3,MAIN_GRAPH4};

double Diapason[8]={6.3,3.15,1.5,750,375, 180,80, 40};

void ConfigGraph(void);
int LoadBios();
void LoadKoeff(void);
void SetAllGain(void);
void ResetAd(void);
void DiskPanel(void);
int ReadFlash(int FAddress);

main()
{
int i, j, k, n, key, hnd, cnt;

    if (!InitLW())
    {
        printf("Unable To Get Call Address.\n");

      return 255;
    };

// 稬  ⥪
OpenInterfaceManager();

// 㧨 ᭮ ࠭
Pnl=LoadPanel("example.uir", MAIN);
SetCtrlVal(Pnl, MAIN_RATE, Rate);
SetCtrlVal(Pnl, MAIN_SCALE, RateScale);
SetCtrlVal(Pnl, MAIN_GAIN, Gain);
SetCtrlVal(Pnl, MAIN_GRID, GridOn=1);
SetCtrlVal(Pnl, MAIN_AUTOSCALE, AutoScale);

// 뢥 ଠ樮 ᮮ饭
SetCtrlVal(Pnl, MAIN_BOX1,
  "  ਬ   ⮡ࠦ  4  ,   DISK");
SetCtrlVal(Pnl, MAIN_BOX1,
  "ਢ ਬ   䠩  ॠ쭮 ⠡ ६  뢠.");
ConfigGraph();
DisplayPanel(Pnl);

// 㧨 ࠢ ணࠬ
LoadBios();

// 㥬 稥 
COMMAND_1221(C_TEST);
i=GET_DM_WORD(L_TEST_LOAD);

//  稨  i   ࠢ 0xAA55
if((unsigned)i != 0xAA55) { MessagePopup("  .");  L1221On=0;      }
  else L1221On=1;

// 稬   
PUT_DM_WORD(L_CHANNEL_MASK, 0x000F);

// ⠭  ᡮ 6.9 
PUT_DM_WORD(L_RATE, Rate);
PUT_DM_WORD(L_RATE_SCALE, RateScale);

// ⠭ 16- ०  
PUT_DM_WORD(L_N_BIT, -4);

// 㧨 ஢ 樥
LoadKoeff();

// ⠭    
SetAllGain();

// ந樠㥬  ࠪ
ResetAd();

for(key=0; !key;)
  {
  GetUserEvent(0, &hnd, &cnt);
  if(hnd == Pnl)
    {
    switch(cnt)
      {
      // 室  ணࠬ
      case MAIN_DONE:
        key=1;
        break;

      // ⠭  
      case MAIN_GAIN:
        GetCtrlVal(Pnl, MAIN_GAIN, &Gain);
        SetAllGain();
        ConfigGraph();
        break;

      // ⠭  
      case MAIN_GRID:
        GetCtrlVal(Pnl, MAIN_GRID, &GridOn);
        for(i=0; i < 4; i++)
          {
          SetGraphAttribute(Pnl, GraphCtrl[i], ATTR_GRAPH_X_AXIS_SHOW_GRID, GridOn);
          SetGraphAttribute(Pnl, GraphCtrl[i], ATTR_GRAPH_Y_AXIS_SHOW_GRID, GridOn);
          }
        break;

      // ⠭  
      case MAIN_AUTOSCALE:
        GetCtrlVal(Pnl, MAIN_AUTOSCALE, &AutoScale);
        ConfigGraph();
        break;

      // ⠭  
      case MAIN_RATE:
        GetCtrlVal(Pnl, MAIN_RATE, &Rate);
        PUT_DM_WORD(L_RATE, Rate);
        COMMAND_1221(C_SET_RATE);
        break;

      // ⠭ ⠡  
      case MAIN_SCALE:
        GetCtrlVal(Pnl, MAIN_SCALE, &RateScale);
        PUT_DM_WORD(L_RATE_SCALE, RateScale);
        break;

      // 맮      ॠ쭮 ६  뢠
      case MAIN_DISK:
        DiskPanel();
        break;
      }
    }

  //  ᨢ  4   ⮡ࠧ   ࠭
  //  ⥪  

  //    
  if(FifoFlag) while(GET_DM_WORD(L_FIFO_PTR) >= L_BUFFER+2048 && !kbhit());
   else while(GET_DM_WORD(L_FIFO_PTR) < L_BUFFER+2048 && !kbhit());

  // ⠥  
  if(FifoFlag) GET_DATA_MEMORY(Data, 2048, L_BUFFER+2048);
    else GET_DATA_MEMORY(Data, 2048, L_BUFFER);

  // 㥬 4 䨪
  for(i=0; i < 4; i++)
    {
    for(j=0; j < 512; j++) DataGraph[j]=Data[i+j*4];
    DeletePlots(Pnl, GraphCtrl[i]);
    PlotWaveform (Pnl, GraphCtrl[i], DataGraph, 512, 1, Diapason[Gain]/32767, 0.0, 0.0, 1.0,
                  0, 0, 0, 0);
    }

  FifoFlag++;
  FifoFlag &= 1;
  }

UnloadPanel(Pnl);
CloseInterfaceManager();
return 0;
}

/*
楤 ⥭ ࠢ饩 ணࠬ  䠩  ᨢ
*/
char* LoadBiosCode(char* FileName)
{
int   BiosFile;
int   NBytes;
char* BiosCode;

/* ஥ 䠩  ࠢ饩 ணࠬ                */
BiosFile=open(FileName, O_BINARY | O_RDONLY);
if(BiosFile == 0) return NULL;

/* ।  䠩                                */
NBytes = filelength(BiosFile);

/* 뤥   ᨢ                            */
BiosCode = (char *)malloc(NBytes+2);
if (BiosCode == NULL) return NULL;

/* ⠥ ⥪ ணࠬ  ᨣ쭮    */
if ( read(BiosFile, BiosCode, NBytes) == -1) return NULL;

/* ஥ 䠩                                         */
close(BiosFile);

/* ୥ 㪠⥫  ᨢ  ணࠬ              */
return BiosCode;
}


/*
楤 㧪 ࠢ饩 ணࠬ   ADSP-2104.
頥   ᯥ譮 㧪.
*/
int LoadBios()
{
int*  LCBios;
int    RCode;

/* ⠥  ணࠬ                                */
LCBios=(int *)LoadBiosCode("lbios016.bio");
if(LCBios == NULL) return 1;

/* 㧨 ணࠬ                         */
RCode=LOAD_ADSP2186((WORD *)LCBios);

/* ᢮   멤  ணࠬ               */
free(LCBios);

return RCode;
}

// २樠  ࠪ
void ResetAd(void)
{
int i, j, *ptr;
int CurrentRate, CurrentScale;

//  ⥪騥 ⠭
CurrentRate=GET_DM_WORD(L_RATE);
CurrentScale=GET_DM_WORD(L_RATE_SCALE);

//  २樠樨   ⠭ 䨪஢ 
PUT_DM_WORD(L_RATE, 11);
PUT_DM_WORD(L_RATE_SCALE, 0);
COMMAND_1221(C_SET_RATE);

// 
delay(50);

//    २樠
COMMAND_1221(C_RESET_AD);

delay(10);

// ,  ⠭  ࠪ
for(i=0; i < 17; i++)
   {
   while(GET_DM_WORD(L_FIFO_PTR) < L_BUFFER+2048 && !kbhit());
   while(GET_DM_WORD(L_FIFO_PTR) >= L_BUFFER+2048 && !kbhit());
   }

// ⠭ ⥪騥  ࠬ
PUT_DM_WORD(L_RATE, CurrentRate);
PUT_DM_WORD(L_RATE_SCALE, CurrentScale);
COMMAND_1221(C_SET_RATE);

FifoFlag=0;
}

void SetAllGain(void)
{
int i;

for(i=0; i < 8; i++)
  {
  PUT_DM_WORD(L_GAIN, Gain);
  PUT_DM_WORD(L_GAIN_CHANNEL, i);
  COMMAND_1221(C_SET_GAIN);
  }
}

void ConfigGraph(void)
{
int i;

for(i=0; i < 4; i++)
  {
  ConfigureAxes(Pnl, GraphCtrl[i], -1, 0.0, 0.0, AutoScale, -Diapason[Gain], Diapason[Gain]);
  }
}

char FlashHeader[]="L-1221 Ver 1.0   ";
char TestC[20];
short ZeroOffset[64], ScaleFactor[64], ZeroOffset1[64];

// 㧪 ஢ 樥⮢  
void LoadKoeff(void)
{
int i;

// ஢ਬ,       ਭ樯
for(i=0; i < 16; i++) TestC[i]=ReadFlash(i);
if(strnicmp(TestC, FlashHeader, strlen(FlashHeader)-1))
  {
  MessagePopup("⮩ ");
  return;
  }

// ⠥ 樥 ᬥ饭   ० ७ ﭪ
for(i=0; i < 64; i++) ZeroOffset[i]= ReadFlash(i*2+16) | (ReadFlash(i*2+16+1) << 8);

// ⠥ 樥 ᬥ饭   ० ७ ⮫쪮 ६
// ⠢饩
for(i=0; i < 64; i++) ZeroOffset1[i]=ReadFlash(i*2+144) | (ReadFlash(i*2+144+1) << 8);

// ⠥ 樥 ⠡   ० ७ ﭪ
for(i=0; i < 64; i++) ScaleFactor[i]=ReadFlash(i*2+272) | (ReadFlash(i*2+272+1) << 8);

PUT_DATA_MEMORY(ZeroOffset, 64, L_ZERO);
PUT_DATA_MEMORY(ZeroOffset1, 64, L_ZERO_FLT);
PUT_DATA_MEMORY(ScaleFactor, 64, L_SCALE);
}

int ReadFlash(int FAddress)
{
PUT_DM_WORD(L_FLASH_ADDRESS, FAddress);
COMMAND_1221(C_FLASH_READ);
delay(5);
return GET_DM_WORD(L_FLASH_BYTE);
}

#pragma codeseg _TEXT "CODE"
/* ********************************************************************** */
void PrintString(LPCSTR s)
{
    _CX=strlen(s);
    _AX=0x4000;
    _BX=2;
    _DS=FP_SEG(s);
    _DX=FP_OFF(s);
    geninterrupt(0x21);
};
/* ********************************************************************** */
// 㭪樨  뢠 STARTUP LCARD_AD.DLL    㫨  RTL.EXE
BOOL WINAPI IsDBCSLeadByte(BYTE)
{
  return FALSE;
};
WORD MyRet=0;
/* ********************************************************************** */
extern "C" FARPROC WINAPI _export _loadds BorlandUnresolvedEntryHook(LPCSTR modName, BOOL byOrdinal, LPCSTR entry)
{
  char s[255];

    MyRet=MyRet+0x100;

    if (byOrdinal)
    {
#ifdef DEBUG
        sprintf(s, "Module Name %s, Function Ordinal %u, Address %X:0000\r\n", modName, FP_OFF(entry), MyRet);
        PrintString(s);
#endif
        if (!(strcmp(modName, "KERNEL")||(((unsigned)entry)!=207))) return (FARPROC)IsDBCSLeadByte;
    } else
    {
#ifdef DEBUG
        sprintf(s, "Module Name %s, Function Name %s, Address %X:0000\r\n", modName, entry, MyRet);
        PrintString(s);
#endif
    };

  // ᫨ 맢  㫨㥬   㤥 exeption 0Dh   TD.EXE
  //  㧭 .
  return (FARPROC)MK_FP(MyRet, 0);
};
