//--------------------------------------------------------------------------
//    :
//     INIT_SIMPLE_INTR, RESET_IRQ, STOP_INTR
//     LCARD_??.DLL, SHOW??.DLL
//--------------------------------------------------------------------------

#define Rate_1 100
#define Rate_2 10
#define MyN    1
#define MyX    1000

#include "lcard_ad.h"
#include <stdio.h>
#include <string.h>
#pragma  hdrstop
#include "show.h"

DWORD MyCount=0;
DWORD OldTime;
DWORD CurTime;
char  s[100];

#ifdef WIN32
BOOL Is_NT=((long)GetVersion())>0;
#endif

/* ********************************************************************** */
//    DSP
HANDLER_TYPE IrqHandler(HANDLER_PARM)
{
    //      DSP
    MyCount++;
#ifdef WIN32
    if(!Is_NT) RESET_IRQ();
#else
    RESET_IRQ();
#endif
};


/* ********************************************************************** */
TMyMakeData MyMakeData()
{
  HDC hDC;

    hDC=GetDC(hWnd);
    CurTime=GetCurrentTime();

    sprintf(s, "Count           %u Tic.", MyCount);
    TextOut(hDC, 10, 10, s, strlen(s));
    sprintf(s, "Time            %u Sec.", (CurTime-OldTime)/1000);
    TextOut(hDC, 10, 30, s, strlen(s));
    sprintf(s, "Irq/Sec         %u Tic/Sec.", MyCount*1000/(CurTime-OldTime));
    TextOut(hDC, 10, 50, s, strlen(s));
    sprintf(s, "Must Be Irq/Sec %u Tic/Sec.", 1000000/Rate_1/Rate_2);
    TextOut(hDC, 10, 70, s, strlen(s));

  return FALSE;
};


/* ********************************************************************** */
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, int)
{
//    SELECT_DEVICE(1);

    MakeData=MyMakeData;

    OldTime=GetCurrentTime();
    INIT_SIMPLE_INTR(Rate_1, Rate_2, IrqHandler);

    InstallShow(hInst, SW_SHOWMAXIMIZED);

    STOP_INTR();                  //   

  return Msg.wParam;
};
