{ ***************************************************************************
      :
       CREATE_CHANNEL_LC201, READ_CALIBR_CC,
       SET_CALIBR_MODE_CC, PROGRAM_FILTER_LC201,
       FORCE_INTER_DELAY_CC, CONFIG_FIFO_CC,
       PROGRAM_USIL_LC201, SET_TRIM_DAC_LC201,
       INTR_SETUP, SET_FIFO_SIZE_CC, SOFT_CONFIG_CC,
       FAST_SOFT_IRQ_START_CC, GET_FAST_SOFT_IRQ_DATA,
       FAST_SOFT_IRQ_STOP_CC, STOP_INTR, OUTDA_AD8842
       LCARD_AD.DLL, SHOW16.DLL
   ************************************************************************** }

program Irq_CC16;
uses
    WinTypes, WinProcs, LCard_ad, Show16;

const
    MyN=10;
    MyX=512;
    MyY=2000;
    FullSize=MyX*MyN;
    HalfSize=FullSize div 2;
    MODES_201_REAL=5;

type
    TData         =array[0..FullSIze-1] of word;
    TPoint        =array[0..FullSize-1] of PointType;
    TPointNumber  =array[0..MyN-1] of word;
    PTPoint       =^TPoint;
    PPTPoint      =^PTPoint;
    PTPointNumber =^TPointNumber;
    PPTPointNumber=^PTPointNumber;

var
    i, j           :word;
    GetingDataCount:word;
    Data           :TData;
    Empty          :array[0..HalfSize-1] of word;
    Channels       :array[0..23] of word;
    Point          :TPoint;
    PointNumber    :TPointNumber;


{*****************************************************************************}
procedure SET_TRIM_DAC_LC201(Slot_201:word;Channel:word;Gain:word);
Begin
   OUTDA_AD8842(Slot_201, Channel*2+0, READ_FLASH_CC(Slot_201, 4*2*MODES_201_REAL+2+Gain*4+Channel) and $FF00 shr 8);
   OUTDA_AD8842(Slot_201, Channel*2+1, READ_FLASH_CC(Slot_201, 4*2*MODES_201_REAL+2+Gain*4+Channel) and $FF);
End;


{*****************************************************************************}
procedure IrqHandler(p:pointer);interrupt;
Begin
    if GetingDataCount>HalfSize then GET_FAST_SOFT_IRQ_DATA(Empty, HalfSize) else
    Begin
        GET_FAST_SOFT_IRQ_DATA(Data[GetingDataCount], HalfSize);
        Inc(GetingDataCount, HalfSize);
    End;

    RESET_IRQ;
End;


{*****************************************************************************}
function MyMakeData:WordBool;export;
Begin
    if GetingDataCount=FullSize then
    Begin
        for i:=0 to MyN-1 do
            for j:=0 to MyX-1 do Point[i*MyX+j].y:=-Data[j*MyN+i];

        GetingDataCount:=0;

        MyMakeData:=True;
        Exit;
    End;

    MyMakeData:=False;
End;


{*****************************************************************************}
Begin
    PMakeData:=@_MakeData;

{    SELECT_DEVICE(1);}

    Rate:=10;
    GetingDataCount:=0;

    PCount^:=MyN;
    PMaxX^:=MyX;
    PMaxY^:=MyY;
    PPenWidth^:=1;
    for i:=0 to MyN-1 do
    Begin
        PointNumber[i]:=MyX;
        for j:=0 to MyX-1 do Point[i*MyX+j].x:=j;
    End;
    PTPoint(PPP^):=@Point;
    PTPointNumber(PPD^):=@PointNumber;
    PMakeData^:=MyMakeData;

    for i:=0 to 3 do
    Begin
        Channels[i*2+0]:=4;
        Channels[i*2+1]:=CREATE_CHANNEL_LC201(i, 1, 1, 0);
        Channels[i*2+0+8]:=5;
        Channels[i*2+1+8]:=CREATE_CHANNEL_LC201(i, 1, 1, 0);
        Channels[i*2+0+16]:=6;
        Channels[i*2+1+16]:=CREATE_CHANNEL_LC201(i, 1, 1, 0);
    End;

    READ_CALIBR_CC;
    SET_CALIBR_MODE_CC(0);
    PROGRAM_FILTER_LC201(4, 5000);
    PROGRAM_FILTER_LC201(5, 5000);
    PROGRAM_FILTER_LC201(6, 5000);
    FORCE_INTER_DELAY_CC(40);
    CONFIG_FIFO_CC(2, 2);

    for i:=0 to 3 do
    Begin
        PROGRAM_USIL_LC201(4, i, 1);
        SET_TRIM_DAC_LC201(4, i, 1);
        PROGRAM_USIL_LC201(5, i, 1);
        SET_TRIM_DAC_LC201(5, i, 1);
        PROGRAM_USIL_LC201(6, i, 1);
        SET_TRIM_DAC_LC201(6, i, 1);
    End;

{    INTR_SETUP(7);}
    SET_FIFO_SIZE_CC(FullSize);
    SOFT_CONFIG_CC(7, MyN, Channels, Rate*MyN);
    FAST_SOFT_IRQ_START_CC(@IrqHandler);

    InstallShow(hInstance, SW_SHOWMAXIMIZED);

    FAST_SOFT_IRQ_STOP_CC;
    STOP_INTR;
End.
