//--------------------------------------------------------------------------
//    :
// INIT_SIMPLE_INTR, STREAM_INTR, SOFT_INTR,
// READ_DATA, RESET_IRQ, STOP_INTR
//    32 BIT  LCARD_32.DLL
//--------------------------------------------------------------------------

#include <conio.h>
#include <stdio.h>
#include "lcard_ad.h"

#define  Channel 0
#define  MyN  2
#define  Rate 1000

DWORD     OldTime;
PTFastIrq PP;
WORD      Channels[16]={0, 1};
BOOL Is_NT=((long)GetVersion())>0;


//    DSP
/* ********************************************************************** */
HANDLER_TYPE SIMPLEIrqHandler(HANDLER_PARM P)
{
  PTFastIrq& PP=(PTFastIrq&)P;

    //      DSP
    if(!((*PP).IrqCount & 0x1FF))
    {
        printf("Interrupt Occured.\n");
        printf("Count:    %d\n", (*PP).Reenter.Count);
        printf("Missing:  %d\n", (*PP).Reenter.Missing);
        printf("IrqCount: %d\n", (*PP).IrqCount);
    };

    if(!Is_NT) RESET_IRQ();
};


//    DSP
/* ********************************************************************** */
HANDLER_TYPE STREAMIrqHandler(HANDLER_PARM P)
{
  PTFastIrq& PP=(PTFastIrq&)P;

    //      DSP
    if(!((*PP).IrqCount & 0x1FF))
    {
        printf("Interrupt Occured.\n");
        printf("Count:    %d\n", (*PP).Reenter.Count);
        printf("Missing:  %d\n", (*PP).Reenter.Missing);
        printf("IrqCount: %d\n", (*PP).IrqCount);
    };

    READ_DATA();
    if(!Is_NT) RESET_IRQ();
};


//    DSP
/* ********************************************************************** */
HANDLER_TYPE SOFTIrqHandler(HANDLER_PARM P)
{
  PTFastIrq& PP=(PTFastIrq&)P;

    //      DSP
    if(!((*PP).IrqCount & 0x1FF))
    {
        printf("Interrupt Occured.\n");
        printf("Count:    %d\n", (*PP).Reenter.Count);
        printf("Missing:  %d\n", (*PP).Reenter.Missing);
        printf("IrqCount: %d\n", (*PP).IrqCount);
    };

    for(int i=0;i<MyN;i++) READ_DATA();
    if(!Is_NT) RESET_IRQ();
};


/* ********************************************************************** */
int main()
{
//    SELECT_DEVICE(1);

    PP=(PTFastIrq)INIT_SIMPLE_INTR(Rate, 0, SIMPLEIrqHandler);
    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    OldTime=GetCurrentTime();
    Sleep(1000);
    printf("Time:     %d\n", GetCurrentTime()-OldTime);
    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    printf("Must Be:  %d\n", 1000000/Rate);
    STOP_INTR();                  //   
    printf("Press Any Key.\n");
    getch();


    PP=(PTFastIrq)STREAM_INTR(Rate, STREAMIrqHandler, Channel);
    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    OldTime=GetCurrentTime();
    Sleep(1000);
    printf("Time:     %d\n", GetCurrentTime()-OldTime);
    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    printf("Must Be:  %d\n", 1000000/Rate);
    STOP_INTR();                  //   
    printf("Press Any Key.\n");
    getch();


    PP=(PTFastIrq)SOFT_INTR(Rate, SOFTIrqHandler, Channels, MyN);
    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    OldTime=GetCurrentTime();
    Sleep(1000);
    printf("Time:     %d\n", GetCurrentTime()-OldTime);
    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    printf("Must Be:  %d\n", 1000000/Rate);
    STOP_INTR();                  //   
    printf("Press Any Key.\n");
    getch();

  return(0);
};
